=begin
#WeFitter API

#This is the WeFitter API

OpenAPI spec version: v1.3
Contact: hello@wefitter.com
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.38
=end

require 'uri'

module WeFitter
  class NotificationApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Notification to all profiles in app
    # Send a notification to all registered devices in the app.
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Notification]
    def notification_send_to_all_create(data, opts = {})
      data, _status_code, _headers = notification_send_to_all_create_with_http_info(data, opts)
      data
    end

    # Notification to all profiles in app
    # Send a notification to all registered devices in the app.
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Notification, Fixnum, Hash)>] Notification data, response status code and response headers
    def notification_send_to_all_create_with_http_info(data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: NotificationApi.notification_send_to_all_create ...'
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling NotificationApi.notification_send_to_all_create"
      end
      # resource path
      local_var_path = '/notification/send_to_all/'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['BearerAdmin']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Notification')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: NotificationApi#notification_send_to_all_create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Notification to specific profiles
    # Send a notification to all registered devices for the specified profiles.
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [NotificationForProfiles]
    def notification_send_to_profiles_create(data, opts = {})
      data, _status_code, _headers = notification_send_to_profiles_create_with_http_info(data, opts)
      data
    end

    # Notification to specific profiles
    # Send a notification to all registered devices for the specified profiles.
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(NotificationForProfiles, Fixnum, Hash)>] NotificationForProfiles data, response status code and response headers
    def notification_send_to_profiles_create_with_http_info(data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: NotificationApi.notification_send_to_profiles_create ...'
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling NotificationApi.notification_send_to_profiles_create"
      end
      # resource path
      local_var_path = '/notification/send_to_profiles/'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['BearerAdmin']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'NotificationForProfiles')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: NotificationApi#notification_send_to_profiles_create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
